#include "display_basic.h"
#include "vend.h"

void delay(u16 ms) {
	/* delay routine written in assembly so we know what we're really getting.
	 * each inner loop should take ~1 ms to execute.
	 * 15 cycles * (1/4.9152Mhz) * 327 = 0.997 ms + a little bit on the fringes.
	 *
	 * XXX - how do we know gcc isn't optimising this? it seems to optimise after
	 * parsing C -> asm, but before asm -> machine code.
	 */
	//asm volatile ("pshx\npsha\npshb\n"); /* save registers */
	asm volatile ("ldx %0\n" :: "m" (ms) : "x");
	asm volatile (
		"delay_loop:\n"
		//"	ldd #327\n"                   /* 3 */
		"	ldd #150\n"                   /* 3 */
		"delay_inner_loop:\n" /* 15 cycles each */
		"	cpd #0x0000\n"                /* 5 */
		"	beq delay_inner_loop_end\n"   /* 3 */
		"	subd #0x0001\n"               /* 4 */
		"	bra delay_inner_loop\n"       /* 3 */
		"delay_inner_loop_end:\n"
		"	dex\n"                        /* 3 */
		"	beq delay_out\n"              /* 3 */
		"	bra delay_loop\n"             /* 3 */
		"delay_out:\n" ::: "x", "d");
		/*"	pulb\n"
		"	pula\n"
		"	pulx\n");*/
}

void my_strncpy(char* dst, char* src, u8 max_size) {
	u8 i;
	for (i = 0; src[i] && i < max_size; i++) dst[i] = src[i];
	if (src[i] == 0 && i < max_size) dst[i] = 0; /* null terminator */
}

bool my_strncmp(char* a, char* b, u8 len) {
	u8 i;
	for (i = 0; i < len; i++) {
		if (*a != *b) return 0;
		a++;
		b++;
	}
	return 1;
}

void my_memcpy(char* dst, char* src, u8 size) {
	u8 i = 0;
	for (i = 0; i < size; i++) dst[i] = src[i];
}

void my_memset(char* dst, u8 val, u16 count) {
	char* c;
	for (c = dst; c < dst+count; c++) *c = val;
}
